SystemOrganization addCategory: #'CompressionTests-Archive'!

TestCase subclass: #ZipArchiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CompressionTests-Archive'!

!ZipArchiveTest methodsFor: 'tests' stamp: 'CamilloBruni 5/4/2012 21:08'!
testCreateWithRelativeNames
	"Test creating a zip with a relative tree of files, so that the tree will
	be created whereever the ."
	| subdir file  zip |
	subdir := FileSystem workingDirectory /  '_test-zip-dir'.
	self deny: subdir exists.
	subdir ensureDirectory.
	[ subdir / '_test-zip-file'  writeStreamDo: [ : stream | stream nextPutAll: 'file contents' ].
	zip := ZipArchive new.
	zip
		addDirectory: subdir fullName
		as: subdir basename.
	zip	
		addFile: (subdir / '_test-zip-file') fullName
		as: '_test-zip-file'.
	file := FileSystem workingDirectory / '_test.zip'.
	zip writeToFileNamed: file fullName ] 
	ensure: [
		zip close.	
		subdir ifNotNil: [ subdir deleteAll ].
		file delete ]
! !

!ZipArchiveTest methodsFor: 'tests' stamp: 'abc 5/11/2012 23:33'!
testDate29Feb2000
	"Ensure that dates with leap years don't screw up in the conversion"

	| archive member theDate |
	theDate := Date year: 2000 month: 2 day: 29.
	archive := ZipArchive new.
	member := archive addDeflateString: 'foo' as: 'bar'.
	member setLastModFileDateTimeFrom: theDate.
	self shouldnt: [member lastModTime] raise: Error.
	self assert: (Date fromSeconds: member lastModTime) = theDate.! !
